.\"     $NetBSD: getiobuf.9,v 1.3 2008/05/06 11:32:47 yamt Exp $
.\"
.\" Copyright (c)2006,2008 YAMAMOTO Takashi,
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\" ------------------------------------------------------------
.Dd May 6, 2008
.Dt GETIOBUF 9
.Os
.Sh NAME
.Nm getiobuf ,
.Nm putiobuf
.Nd I/O descriptor allocation interface
.\" ------------------------------------------------------------
.Sh SYNOPSIS
.In sys/buf.h
.Ft struct buf *
.Fn getiobuf "struct vnode *vp" "bool waitok"
.Ft void
.Fn putiobuf "struct buf *bp"
.\" ------------------------------------------------------------
.Sh DESCRIPTION
.\" - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
.Fn getiobuf
allocates a
.Em buf
structure.
.Pp
.Bl -tag -width waitok
.It Fa vp
The vnode to which the allocated buffer will be associated.
This can be
.Dv NULL .
.It Fa waitok
If true,
.Fa getiobuf
can sleep until enough memory is available.
Otherwise, it returns
.Dv NULL
immediately if enough memory is not available.
.El
.Pp
Note that the allocated buffer doesn't belong to buffer cache.
To free it,
.Fn putiobuf
should be used.
.Fn brelse
should not be used on it.
.Pp
.\" - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
.Fn putiobuf
frees
.Fa bp ,
which should be a buffer allocated with
.Fn getiobuf .
.\" - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
.Sh SEE ALSO
.Xr buffercache 9 ,
.Xr intro 9
